<script setup>
import { ref, computed } from 'vue';
import Settings from 'modules/settings';
import ItemGroup from 'ui/panes/itemGroup.vue';
import { useHidable } from '../composables/use-hidable';

/**
 * @property {Resource[]} items
 */
const props = defineProps(['items']);

const ops = Settings.getSubVars('resview');
if (!ops.hide) ops.hide = {};

//hide: ops.hide

const btnHide = ref();
const elRef = ref();
const { hides } = useHidable(btnHide, elRef);

/**
 * @property {.<string,GData[]>} groups - maps group name to items array.
 */
const groups = computed(() => {

	// build item groups.
	const items = props.items;
	const grps = {
		other: []
	}

	const len = items.length;
	for (let i = 0; i < len; i++) {

		const it = items[i];
		if (it.hide) continue;
		const title = it.group || (it.tags ? it.tags[0] : 'other');
		if (title === 'manas' || title === 'menace' || title === 'specialty' || title === 't_endurance') continue;

		const group = grps[title] || (grps[title] = []);

		group.push(it);

	}

	return grps;

});
</script>


<template>
<div class="res-list">
    <div class="config"><button ref="btnHide" class="btnConfig"></button></div>
    <div class="res-container" ref="elRef">
        <ItemGroup class="res-group" v-for="(g, p) in groups"
			:items="g" :group="p" :hide="hides" :key="p" />
    </div>
</div>
</template>

<style scoped>
div.res-list {
	overflow-y: auto;
	overflow-x: visible;
	width: fit-content;
	margin: 0;
	padding: 0;
	min-width: 11rem;
}

@supports (-moz-appearance:button) and (contain:paint) {
	div.res-list {
		overflow-y: auto;
		overflow-x: visible;
		width: fit-content;
		margin: 0;
		padding: 0;
		min-width: 11rem;
	}

	div.res-container {
		overflow-x: visible;
		width: fit-content;
		padding-right: 1.1rem;
		min-width: 11rem;
	}
}
</style>